/*
 *	LiMon - BOOTP/TFTP.
 *
 *	Copyright 1994, 1995, 2000 Neil Russell.
 *	(See License)
 */

#ifndef __TFTPSRV_H__
#define __TFTPSRV_H__
#ifdef CAMEO_DISCOVERY

/**********************************************************************/
/*
 *	Global functions and variables.
 */

/* tftpsrv.c */
extern void TftpFwUpgradeStart (void);

#define UDP_TFTPSRV_FWUPGRADE_PORT            0xFC05


#define MAX_FIRMWARE_IMAGE_SIZE		(1024*1024*8)
#ifndef CAMEO_MODEL_NAME
#define CAMEO_MODEL_NAME "DGS-1224T"
#endif /* CAMEO_MODEL_NAME */
#define SYS_PRODUCT_NAME_LEN        20
#define IMAGE_BOOT                  "boot"
#define IMAGE_OS					"os"
#define IMAGE_CRAMFS				"squashfs"
#define MaxImageTypeLen				16
#define IMAGE_OS_TYPE				1
#define IMAGE_CRAMFS_TYPE			2


/*error code*/
#define ERR_OTHER		        0x0000
#define ERR_NOTFOUND	        0x0001
#define ERR_ACCESS	            0x0002
#define ERR_NOSPACE	            0x0003
#define ERR_ILLEGAL	            0x0004
#define ERR_PORT		        0x0005
#define ERR_EXISTS	            0x0006
#define ERR_NOUSER	            0x0007

/**********************************************************************/
#define  UBOOOT_GO_RUNTIME_CMD  "reset"

#endif

#endif /* __TFTPSRV_H__ */
